<template>
  <div class="scroll">
    <div class="middle">
      <div class="filter">
        <div class="condition">
          <span>新闻分类 :</span>
          <el-select
            clearable
            v-model="searchInput.categoryId"
            placeholder="请选择新闻分类"
          >
            <el-option
              v-for="i in newTypeData"
              :key="i.id"
              :label="i.name"
              :value="i.id"
            />
          </el-select>
        </div>
        <div class="condition">
          <span>发布人 :</span>
          <el-input
            clearable
            v-model.trim="searchInput.userName"
            class="w-50 m-2"
            placeholder="请输入发布人"
            style="width: 180px"
          />
        </div>
        <div class="condition">
          <span>发布时间 :</span>
          <el-date-picker
            v-model="searchInput.createTime"
            unlink-panels
            type="datetimerange"
            range-separator="-"
            start-placeholder="起始时间"
            end-placeholder="结束时间"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
            placeholder="请选择日期"
          />
        </div>
        <el-button
          style="margin-left: 20px"
          color="rgba(38, 151, 255, 1)"
          type="primary"
          class="search"
          @click="searchBtn"
          ><span>查询</span></el-button
        >
        <el-button @click="resetBtn" plain color="rgba(43, 153, 255, 1)"
          >重置</el-button
        >
      </div>
      <!-- 按钮列表 -->
      <div class="gongneng">
        <el-button
          type="primary"
          style="margin-left: 0"
          color="rgba(38, 151, 255, 1)"
          @click="addlist"
          >发布新闻</el-button
        >
      </div>
    </div>
    <div class="footer" v-loading="loading">
      <el-table
        :row-class-name="tableRowClassName"
        :data="tableData.list"
        @selection-change="handleSelectionChange"
        style="width: 100%"
        :header-cell-style="{
          background: 'rgba(240, 243, 247, 1)',
          height: '50px',
          border: 0,
        }"
      >
        <!-- <el-table-column type="selection" align="center" width="55" /> -->
        <el-table-column align="center" prop="theme" label="新闻标题" />
        <el-table-column width="100" align="center" label="相册分类">
          <template #default="{ row }">
            <span>{{ row.categoryName }}</span>
          </template>
        </el-table-column>
        <el-table-column align="center" prop="content" label="新闻内容">
          <template #default="{ row }">
            <!-- 容器1：用于渲染 HTML 内容（隐藏溢出，配合 tooltip） -->
            <div
              class="html-content"
              style="color: #2697ff; cursor: pointer"
              @click="handleTooltipShow(row.content)"
            >
              详情
            </div>
          </template>
        </el-table-column>
        <el-table-column align="center" prop="userName" label="发布人" />
        <el-table-column align="center" prop="college" label="联系方式" />
        <el-table-column align="center" prop="createTime" label="发布时间" />
        <el-table-column align="center" label="操作" fixed="right" width="200">
          <template #default="{ row }">
            <el-button type="primary" @click="updateS(row)" link
              >编辑</el-button
            >
            <el-button type="danger" @click="deleteS(row)" link>删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <!-- 分页组件 -->
      <div class="pageSize">
        <span></span>
        <el-pagination
          background
          :current-page="currentPage"
          :page-size="pageSize"
          :page-sizes="[10, 20, 30, 40]"
          layout="total,sizes, prev, pager, next, jumper, slot"
          :total="total"
          @size-change="handleSizeChange"
          @update:current-page="handleCurrentChange"
        />
      </div>
    </div>
    <el-dialog
      class="tooltips"
      v-model="tooltipVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      title="新闻内容"
      align-center
      width="1000"
      destroy-on-close
      draggable
    >
      <span v-html="tooltipContent"></span>
    </el-dialog>
  </div>
  <!-- 添加账号弹窗 -->
  <el-dialog
    class="addStaff"
    v-model="addDialogVisible"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    :title="dialongTitle"
    align-center
    width="890"
    :before-close="cancelAdd"
    destroy-on-close
    draggable
  >
    <el-form
      ref="ruleFormRef"
      :model="ruleForm"
      :rules="rules"
      label-width="100px"
      class="demo-ruleForm"
      :size="formSize"
      label-position="right"
      status-icon
    >
      <el-form-item label="封面图 :" prop="coverImg">
        <div class="img-preview-list">
          <div class="img-item" v-if="ruleForm.coverImg">
            <img
              v-viewer
              :src="ruleForm.coverImg"
              alt="图片预览"
              class="preview-img"
              @click="handlePreview(ruleForm.coverImg)"
            />
            <span class="delete-btn" @click="handleDelete(index)">
              <el-icon><Delete /></el-icon>
            </span>
          </div>
          <el-upload
            action="#"
            :auto-upload="false"
            :on-change="handleFileChange"
            :before-upload="beforeUpload"
            class="upload-btn"
            accept="image/*"
          >
            <el-icon><Plus /></el-icon>
            <span class="upload-txt">点击上传图片</span>
          </el-upload>
        </div>
      </el-form-item>
      <el-form-item label="新闻标题 :" prop="theme">
        <el-input
          clearable
          v-model.trim="ruleForm.theme"
          class="w-50 m-2"
          placeholder="请输入新闻标题"
        />
      </el-form-item>
      <el-form-item label="新闻分类 :" prop="categoryId">
        <el-select
          @change="schoolFormChange"
          v-model="ruleForm.categoryId"
          clearable
          placeholder="请选择新闻分类"
        >
          <el-option
            v-for="i in newTypeData"
            :key="i.id"
            :label="i.name"
            :value="`${i.name},${i.id}`"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="新闻内容 :" prop="content">
        <!-- <el-input
          v-model.trim="ruleForm.bedNumber"
          placeholder="请输入新闻内容"
          clearable
          :autosize="{ minRows: 4 }"
          type="textarea"
        /> -->
        <Richtext
          @richtextClick="richtextClick"
          :fatherMessage="fatherMessage"
        ></Richtext>
      </el-form-item>
      <el-form-item class="options">
        <el-button @click="cancelAdd">取消</el-button>
        <el-button
          color="rgba(0, 97, 255, 1)"
          class="queding"
          type="primary"
          @click="submitAdd(ruleFormRef)"
        >
          确定
        </el-button>
      </el-form-item>
    </el-form>
  </el-dialog>
  <!-- 项目导入 -->
  <el-dialog
    class="projectImport"
    v-model="buildImportVisible"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
    title="寝室信息导入"
    align-center
    width="600"
    :before-close="cancelProjectImport"
  >
    <!-- <p class="title">当前只支持项目类型为“非装配式建筑项目”的项目导入</p> -->
    <p class="down">
      <span>寝室信息导入模板下载</span
      ><span @click="templateDown">模板下载</span>
    </p>
    <el-upload
      class="avatar-uploader"
      action="#"
      :auto-upload="false"
      :on-remove="projectImportRemove"
      :on-change="projectImportChange"
      :before-upload="beforeAvatarProImport"
      ref="buildRef"
      :limit="1"
      :on-exceed="projectImportExceed"
    >
      <template #trigger>
        <el-button class="queding" type="primary">
          &nbsp;&nbsp;导入文件&nbsp;&nbsp;
        </el-button>
      </template>
    </el-upload>
    <div class="options">
      <el-button
        color="rgba(9, 101, 98, 1)"
        class="queding"
        type="primary"
        @click="projectImportConfirm(buildRef)"
        :loading="buildImportLoading"
      >
        &nbsp;&nbsp;确认导入&nbsp;&nbsp;
      </el-button>
      <el-button @click="cancelProjectImport"
        >&nbsp;&nbsp;取消导入&nbsp;&nbsp;</el-button
      >
    </div>
  </el-dialog>
</template>

<script setup>
import {
  ref,
  watch,
  reactive,
  nextTick,
  onBeforeMount,
  onUnmounted,
} from "vue";
import { useRouter } from "vue-router";
import { genFileId, ElMessage, ElMessageBox } from "element-plus";
import { dayjs } from "element-plus";
import lodash from "lodash";
import { Delete, Download, Plus, ZoomIn } from "@element-plus/icons-vue";

import { storeToRefs } from "pinia";
import { useCounterStore } from "@/stores/index";

import Richtext from "@/components/Richtext.vue";

import {
  queryCategoryNewss,
  queryAlumniNewsPage,
  insertAlumniNews,
  updateAlumniNews,
  deleteAlumniNews,
} from "@/api/alumni-new.js";
import { uploadFile } from "@/api/uploadFile";

const router = useRouter();
const store = useCounterStore();

// 为避免解构时失去响应性
const { name, age, isCollapse, realAge, collegeRole } = storeToRefs(store);

// 表格数据
const loading = ref(false);
const tableData = reactive({
  list: [{}],
});
const dialongTitle = ref("新增账号"); // 弹窗标题

const searchInput = reactive({
  categoryId: "",
  userName: "",
  createTime: "",
}); // 搜索按钮数据

const currentPage = ref(1); // 当前页
const pageSize = ref(10);
const total = ref(0); // 当前总数
const selectIds = ref([]); // 勾选的全部数据
const newTypeData = ref([]); //新闻分类下拉数据

const addDialogVisible = ref(false); // 控制添加账号弹窗

// 表单数据
const formSize = ref("default");
const ruleFormRef = ref();
const ruleForm = reactive({
  coverImg: "",
  theme: "",
  categoryId: "",
  content: "",
  id: "",
});
// 表单验证
const rules = reactive({
  coverImg: [{ required: true, message: "封面图不能为空", trigger: "blur" }],
  theme: [{ required: true, message: "标题不能为空", trigger: "blur" }],
  categoryId: [
    { required: true, message: "所属分类不能为空", trigger: "blur" },
  ],
  content: [{ required: true, message: "内容不能为空", trigger: "blur" }],
});

// Tooltip 相关响应式变量
const tooltipVisible = ref(false);
const tooltipContent = ref("");

// 处理 Tooltip 显示（判断是否溢出 + 更新内容）
const handleTooltipShow = (htmlContent) => {
  tooltipVisible.value = true;
  tooltipContent.value = htmlContent;
};

// 获取账户列表
const getList = async () => {
  loading.value = true;
  let params = {
    currentPage: currentPage.value, // 当前页
    pageCount: pageSize.value, // 一页数据条数
    categoryId: searchInput.categoryId,
    userName: searchInput.userName,
  };
  if (searchInput.createTime) {
    params.startTime = searchInput.createTime[0];
    params.endTime = searchInput.createTime[1];
  }
  queryAlumniNewsPage(params).then((res) => {
    console.log(res, "获取新闻分页数据");
    if (res.code == 200) {
      tableData.list = res.data.list;
      total.value = res.data.totalCount;
      loading.value = false;
    } else {
      loading.value = false;
      ElMessage({
          type: "error",
          showClose: true,
          message: res.message,
          center: true,
        });
    }
  });
};

// 搜索功能
const searchBtn = lodash.debounce(async () => {
  currentPage.value = 1;
  getList();
}, 300);
const resetBtn = lodash.debounce(async () => {
  searchInput.categoryId = "";
  searchInput.userName = "";
  searchInput.createTime = "";
  currentPage.value = 1;
  getList();
}, 300);

const handleDelete = (index) => {
  ruleForm.coverImg = "";
};

const handlePreview = (images) => {
  // 核心：复制数组，把点击的图片移到第一位
  // const newImages = [...images]; // 拷贝原数组，避免修改原数据
  // const currentImg = newImages.splice(index, 1)[0]; // 取出当前点击的图片
  // newImages.unshift(currentImg); // 放到数组开头
  // 传给预览器，此时插件显示的第一张就是点击的图片
  // viewerApi({
  //   images: newImages,
  //   zIndex: 3000,
  // });
};

// 上传前的校验
const beforeUpload = (file) => {
  // 校验文件类型
  const isImage = file.type.startsWith("image/");
  if (!isImage) {
    ElMessage.error("只能上传图片格式文件");
    return false;
  }
  // 校验文件大小（2MB）
  const isLt2M = file.size / 1024 / 1024 < 2;
  if (!isLt2M) {
    ElMessage.error("图片大小不能超过2MB");
    return false;
  }
  return true;
};

// 文件选择变化时触发
const handleFileChange = async (file, newFileList) => {
  console.log(file);
  let formData = new FormData();
  formData.append("file", file.raw);
  let res = await uploadFile(formData);
  // console.log(res.data.fileUrl);
  if (res.code == 200) {
    ruleForm.coverImg = res.data.fileUrl; // 赋值给响应式fileList，页面自动刷新
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

// 添加账号
const addlist = () => {
  dialongTitle.value = "发布新闻";
  addDialogVisible.value = true;
  ruleForm.coverImg = "";
  ruleForm.theme = "";
  ruleForm.categoryId = "";
  ruleForm.content = "";
  fatherMessage.value.data =""
  ruleForm.id = "";
};
// 添加账号
const updateS = (row) => {
  console.log(row);
  dialongTitle.value = "编辑新闻";
  addDialogVisible.value = true;
  ruleForm.coverImg = row.coverImg;
  ruleForm.theme = row.theme;
  ruleForm.categoryId = `${row.categoryName},${row.categoryId}`;
  ruleForm.content = row.content;
  fatherMessage.value.data = row.content;
  ruleForm.id = row.id;
};
const deleteS = async (row) => {
  ElMessageBox.confirm("是否删除此数据?", "提示!!!", {
    confirmButtonText: "确认",
    cancelButtonText: "取消",
    type: "warning",
  })
    .then(async () => {
      let params = {
        id: row.id,
      };
      let res = await deleteAlumniNews(params);
      if (res.code == 200) {
        getList();
        ElMessage({
          type: "success",
          showClose: true,
          message: res.message,
          center: true,
        });
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: res.message,
          center: true,
        });
      }
    })
    .catch(() => {
      loading.value = false;
    });
};

// 确认添加员工
const submitAdd = lodash.debounce(async (formEl) => {
  if (!formEl) return;
  await formEl.validate(async (valid, fields) => {
    if (valid) {
      let data = {
        categoryId: ruleForm.categoryId.split(",")[1],
        categoryName: ruleForm.categoryId.split(",")[0],
        theme: ruleForm.theme,
        coverImg: ruleForm.coverImg,
        content: ruleForm.content,
      };
      let res = "";
      if (dialongTitle.value == "发布新闻") {
        res = await insertAlumniNews(data);
      } else {
        data.id = ruleForm.id;
        res = await updateAlumniNews(data);
      }
      if (res.code == 200) {
        addDialogVisible.value = false;
        ElMessage({
          type: "success",
          showClose: true,
          message: res.message,
          center: true,
        });
        getList();
      } else {
        ElMessage({
          type: "error",
          showClose: true,
          message: res.message,
          center: true,
        });
      }
    } else {
      console.log("error submit!", fields);
    }
  });
}, 1000);

const cancelAdd = () => {
  addDialogVisible.value = false;
};

// 多选框功能
const handleSelectionChange = (val) => {
  // console.log(val);
  selectIds.value = val.map((i) => i.id);
  console.log(selectIds.value);
  
};

// 表格斑马纹颜色修改
const tableRowClassName = ({ row, rowIndex }) => {
  if (rowIndex % 2 === 0) {
    return "even";
  } else if (rowIndex % 2 !== 0) {
    return "odd";
  }
  return "";
};
// 每页显示条数
const handleSizeChange = (value) => {
  console.log(value, "每页显示条数");
  pageSize.value = value;
  getList()
};
// 分页
const handleCurrentChange = (value) => {
  // console.log(value);
  currentPage.value = value;
  getList()
};

const cancelProjectImport = () => {
  buildImportVisible.value = false;
  if (buildRef.value) {
    buildRef.value.clearFiles();
    buildFile.value = null;
  }
};

const newTypeList = async () => {
  let res = await queryCategoryNewss();
  console.log(res, "新闻分类下拉列表数据");
  if (res.code == 200) {
    newTypeData.value = res.data;
  } else {
    ElMessage({
      type: "error",
      showClose: true,
      message: res.message,
      center: true,
    });
  }
};

const fatherMessage = ref({
  data: "",
  flag: false,
});
// 富文本传过来的数据
const richtextClick = (data) => {
  // console.log(data, "富文本传过来的数据");
  // params.value.safetyNotice = data.html;
  fatherMessage.value.data=data.html
  ruleForm.content = data.html;
  // accountRuleForm.contentText = data.text;
};

onBeforeMount(() => {
  getList();
  newTypeList();
});
onUnmounted(() => {
  // document.removeEventListener("keyup", Enters);
});
</script>

<style scoped lang="scss">
.scroll {
  width: calc(100% - 60px);
  height: calc(100% - 61px);
  margin: 0 auto;
  display: flex;
  flex-direction: column;

  .middle {
    width: calc(100%);
    color: #000;
    .filter {
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      .search {
        margin-left: 0 !important;
        color: #fff;
      }
      .condition {
        display: flex;
        align-items: center;
        margin: 10px 30px 10px 0;
        :deep(.el-input .el-input__inner) {
          font-size: 14px;
        }
        .el-select {
          width: 220px;
        }
        span {
          margin: 0 10px 0 0;
        }
      }
    }
    .gongneng {
      margin: 10px 0;
      .el-button {
        color: #fff;
        margin-right: 15px;
      }
    }
  }
  .footer {
    width: calc(100%);
    flex: 1;
    margin: 0 auto;
    overflow: auto;

    .el-table--fit {
      height: calc(100% - 60px);
      :deep(.el-table__header-wrapper) {
        background-color: #000;
        font-size: 15px;
        color: #000;
        .cell {
          color: #000;
        }
      }
      :deep(.el-table__row) {
        height: 50px;
        font-size: 15px;
        color: #000;
      }
      :deep(.el-table__row td) {
        padding: 0;
        border: 0;
      }

      .el-button--primary {
        margin-left: 5px;
      }
      :deep(.el-table__body .even) {
        background-color: #fff;
      }
      :deep(.el-table__body .odd) {
        background-color: rgba(240, 243, 247, 1);
      }
    }

    .pageSize {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin: 0 30px;
      height: 60px;

      span {
        color: #000;
      }

      .el-pagination {
        // width: 1600px;
        :deep(.el-pagination__total) {
          color: #000;
        }

        :deep(.el-pagination__goto) {
          color: #000;
        }

        :deep(.el-pagination__classifier) {
          color: #000;
        }

        :deep(.el-input__wrapper) {
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          box-shadow: none;
        }

        :deep(.el-pager li) {
          margin: 0 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }

        :deep(.el-pager li.is-active) {
          // background-color: rgba(0, 97, 255, 0.8);
          border: 1px solid rgba(0, 97, 255, 1);
          color: rgba(0, 97, 255, 1);
        }

        :deep(.btn-prev) {
          margin-right: 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }

        :deep(.btn-next) {
          margin-left: 5px;
          border: 1px solid rgba(0, 0, 0, 1);
          border-radius: 5px;
          background-color: transparent;
        }
      }
    }
  }
}

// 添加员工弹窗样式
:deep(.addStaff) {
  .el-dialog__body {
    padding: 20px 20px 10px 20px;
    .el-input {
      width: 400px;
      .el-input__suffix-inner {
        color: rgba(61, 81, 232, 1);
      }
    }
    .el-textarea {
      width: 400px;
    }
    .el-select {
      width: 400px;
    }
    .el-tree {
      width: 400px;
    }
    .options {
      margin: 50px 0 30px 0;
      display: flex;
      flex-direction: row-reverse;
      .queding {
        margin-left: 20px;
        background: linear-gradient(
          90deg,
          rgba(38, 151, 255, 1) 0%,
          rgba(102, 181, 255, 1) 100%
        );
        border: none;
      }
      .quxiao {
        border: 1px solid rgba(43, 151, 252, 1);
        color: rgba(43, 151, 252, 1);
      }
    }
  }
}

:deep(.tooltips) {
  .el-dialog__body {
    height: 500px;
    overflow: auto;
    padding: 0px 20px 10px 20px;
  }
}
</style>
